package main;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class Gui implements ActionListener {
	
	private Main main;
	
	JFrame mainFrame;
	JPanel mainPanel;
	
	JLabel addressLabel;
	JTextField addressField;
	
	JButton startButton, stopButton;
	
	public Gui(Main main) {
		
		this.main = main;
		
		mainFrame = new JFrame("Gui");
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new FlowLayout());
		mainPanel.setPreferredSize(new Dimension(170, 65));
		
		addressLabel = new JLabel("Address:");
		
		addressField = new JTextField("");
		addressField.setPreferredSize(new Dimension(100, 20));
		
		startButton = new JButton("Start");
		startButton.setActionCommand("start");
		startButton.addActionListener(this);
		
		stopButton = new JButton("Stop");
		stopButton.setActionCommand("stop");
		stopButton.addActionListener(this);
		
		mainPanel.add(addressLabel);
		mainPanel.add(addressField);
		mainPanel.add(startButton);
		mainPanel.add(stopButton);
		mainFrame.add(mainPanel);
		
		mainFrame.setLocationRelativeTo(null);
		mainFrame.pack();
		mainFrame.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand().matches("stop")) {
			if(Main.mci!=null) {
				Main.mci.Stop();
				Main.mci.Blank(main.edlName, 0, Integer.MAX_VALUE, 0,0,0,false);
				main.disconnectMCR();
			}
			System.exit(0);
		}
		if(e.getActionCommand().matches("start")) {
			Object address = null;
			String strAddress = addressField.getText();
			if(strAddress.split(".").length != 4) {
				address = strAddress;
			} else {
				String[] ipParts = strAddress.split(".");
				byte[] ip = new byte[4];
				for(int i=0;i<4;i++) {
					try {
						int ipNr = Integer.parseInt(ipParts[i]);
						if(ipNr<=255 && ipNr >= 0) {
							ip[i] = (byte)ipNr;
						} else {
							System.out.println("Invalid IP");
						}
					} catch (NumberFormatException nfe) {
						System.out.println("NumberFormatException, invalid IP");
						System.out.println("Trying as dns");
					}
				}
				address = ip;
			}
			main.Connect(address, 4444);
			startButton.setEnabled(false);
		}
		
	}
	
}
