package packetNetworking;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.io.Serializable;

/**
 *
 * @author Stian
 */
public class ObjectSender {
	
	PrintStream out;
	
    /**
     * The object sender only needs a printstream to stream to.
     * Arguments passed to the object sender is passed as method input
     * @param pw
     */
    public ObjectSender(PrintStream pw) {
		
		out = pw;
		
	}
	
    /**
     * Sends an object to the print stream
     * @param object
     */
    public void SendObject(Serializable object) {

        //Serialize the object by parsing it into bytes
		byte[] bytes = Serialize(object);
        //First send the length of the object
		int length = bytes.length;
		out.write((byte)(length >> 0));
		out.write((byte)(length >> 8));
		out.write((byte)(length >> 16));
		out.write((byte)(length >> 24));

        //Then send the data itself
		try {
			out.write(bytes);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}


    /**
     * Encodes an object by turning it into bytes
     * @param object
     * @return
     */
    public byte[] Serialize(Serializable object) {
		
		byte[] byteArray = null;
		try {
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			ObjectOutputStream objstream = new ObjectOutputStream(bos);
			objstream.writeObject(object);
			byteArray = bos.toByteArray();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return byteArray;
	}
	
}
