package packets;

import java.io.Serializable;

/**
 *
 * @author Stian
 */
public class Clip implements Serializable {
	
	private static final long serialVersionUID = -5789851181227731559L;
	private static int counter = 0;
    /**
     * Id of the clip. Unique identifier
     */
    public int id;
    /**
     * Name of the clip. This is the file name in the folder
     */
    public String name;
    /**
     * The pathname of the clip is the full path of the clip as used on the clip recorder
     */
    public String pathname;
    /**
     * The length of the clip, given in time code format
     */
    public String length;
	
    /**
     * Constructor with name as input, this just sets a name and generates and id.
     * Pathname and length must be set with the public methods
     * @param name
     */
    public Clip(String name) {
		id = counter;   //Set id
		counter++;      //Increment counter
		this.name = name;
	}
	
    /**
     * Sets the clips path
     * @param path
     */
    public void setPath(String path) {
		pathname = path;
	}
	
    /**
     * Sets the clips length
     * @param length
     */
    public void setLength(String length) {
		this.length = length;
	}


    /*
     * Overrides toString() from Object
     * */
    @Override
	public String toString() {
		return "Clip: "+id+", "+name+", "+pathname+", "+length;
	}

}
