package SALT.assessment;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * FilterLOG can be set on a JFileChooser to keep unwanted files from appearing in the directory listing.
 * @see javax.swing.filechooser.FileFilter
 */
public class FilterLOG extends FileFilter {
    
    /**
     * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
     */
    public boolean accept(File file) {
        if (file.isDirectory()) {
            return true;
        }
        return file.getName().endsWith(".log"); 
    }

    /**
     * @see javax.swing.filechooser.FileFilter#getDescription()
     */
    public String getDescription() {
        return "LOG-Files (*.log)";
    }
} 
