package SALT.gui;

import java.awt.GridBagConstraints;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import SALT.assessment.Design;

/**
 * An input dialog to enter AdditionalSubjectInfos.
 *
 */
public class AdditionalSubjectInfoDialog extends Dialog {

	JPanel panel;
	JLabel meaningLabel;
	JTextField meaningTextField;

	/**
	 * Constructs an AdditionalSubjectInfoDialog.
	 */
	public AdditionalSubjectInfoDialog() {

		panel = new JPanel(gridBagLayout);
		meaningLabel = new JLabel("Subject Info");
		meaningTextField = new JTextField(10);

		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(meaningLabel, gridBagConstraints);
		panel.add(meaningLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(meaningTextField, gridBagConstraints);
		panel.add(meaningTextField);
	}

	/**
	 * Displays the AdditionalSubjectInfoDialog.
	 * @param frame
	 * @param design
	 * @param name
	 * @param displayTitle
	 * @return
	 */
	public String display(JFrame frame, Design design, String name,
			String displayTitle) {
		
		// For editing a subject info.
		if (name.length() != 0) {
			meaningTextField.setText(name);
		}

		int choosedOption = JOptionPane.showOptionDialog(frame, panel,
				displayTitle, JOptionPane.DEFAULT_OPTION,
				JOptionPane.INFORMATION_MESSAGE, null, options, options[0]);

		if (choosedOption == 0) {
			// For entering a subject info.
			if (name.length() == 0) {
				if (meaningTextField.getText().length() != 0)
				design.addAdditionalSubjectInfo(meaningTextField.getText());
			} 
			// For editing a subject info.
			else {
				design.removeAdditionalSubjectInfo(name);
				design.addAdditionalSubjectInfo(meaningTextField.getText());
			}
			
			String temp = new String(meaningTextField.getText());
			meaningTextField.setText("");
			return temp;

		} else {
			meaningTextField.setText("");
			if (name.length() != 0) {
				return name;
			} else {
				return meaningTextField.getText();
			}
		}
	}
}
