/**
 * 
 */
package SALT.gui;

import java.awt.GridBagConstraints;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import SALT.assessment.Design;

/**
 * An input dialog to enter new continuous button numbers.
 *
 */
public class ContinuousDialog extends Dialog {

	JPanel panel;
	JLabel Label;	
	
	JFrame frame;
	
	JComboBox MIDIButtonNumberForwardComboBox;
	JComboBox MIDIButtonNumberBackwardComboBox;
	JComboBox MIDIButtonNumberContinuousComboBox;
	
	JComboBox ContinuousComboBox;	
	String[] ContinuousComboBoxItems = { "73", "72", "71",
			"70", "69", "68", "67", "66", "65", "64", "63", "62", "61",
	"60" };
	
	/**
	 * Constructs a ContinuousDialog.
	 */
	public ContinuousDialog (){
			
		panel = new JPanel(gridBagLayout);
		Label = new JLabel("Button Number");				
		
		ContinuousComboBox = new JComboBox(ContinuousComboBoxItems);
		ContinuousComboBox.setSelectedItem("71");
		
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(Label, gridBagConstraints);
		panel.add(Label);
		
		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(ContinuousComboBox, gridBagConstraints);
		panel.add(ContinuousComboBox);
	}
	
	/**
	 * Displays the ContinuousDialog.
	 * @param frame
	 * @param design
	 * @param selectedItem
	 */
	public String display(JFrame frame, Design design,
			JComboBox MIDIButtonNumberForwardComboBox,
			JComboBox MIDIButtonNumberBackwardComboBox,
			JComboBox MIDIButtonNumberContinuousComboBox) {

		this.MIDIButtonNumberForwardComboBox = MIDIButtonNumberForwardComboBox;
		this.MIDIButtonNumberBackwardComboBox = MIDIButtonNumberBackwardComboBox;
		this.MIDIButtonNumberContinuousComboBox = MIDIButtonNumberContinuousComboBox;

		boolean wrongInput = true;

		while (wrongInput == true) {
			wrongInput = false;

			int choosedOption = JOptionPane.showOptionDialog(frame, panel,
					"New Button Number", JOptionPane.DEFAULT_OPTION,
					JOptionPane.INFORMATION_MESSAGE, null, options, options[0]);

			if (choosedOption == 0) {
				if (ContinuousComboBox.getSelectedItem().equals(
						MIDIButtonNumberForwardComboBox.getSelectedItem())) {
					JOptionPane.showMessageDialog(frame,
							"MIDI Button Number already used! \n", "Warning!",
							JOptionPane.ERROR_MESSAGE);
					ContinuousComboBox.setSelectedItem("71");
					wrongInput = true;
				}
				if (ContinuousComboBox.getSelectedItem().equals(
						MIDIButtonNumberBackwardComboBox.getSelectedItem())) {
					JOptionPane.showMessageDialog(frame,
							"MIDI Button Number already used! \n", "Warning!",
							JOptionPane.ERROR_MESSAGE);
					ContinuousComboBox.setSelectedItem("71");
					wrongInput = true;
				}
				for (int i = 0; i < MIDIButtonNumberContinuousComboBox
						.getItemCount(); i++) {
					if (ContinuousComboBox.getSelectedItem().equals(
							MIDIButtonNumberContinuousComboBox.getItemAt(i))) {
						JOptionPane.showMessageDialog(frame,
								"MIDI Button Number already used! \n",
								"Warning!", JOptionPane.ERROR_MESSAGE);
						ContinuousComboBox.setSelectedItem("71");
						wrongInput = true;
					}
				}

			} else {
				ContinuousComboBox.setSelectedItem("71");
				return "";
			}
		}
		return ContinuousComboBox.getSelectedItem().toString();
	}
}
