package SALT.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.List;
import java.util.Vector;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;

import javax.swing.*;
import javax.swing.border.TitledBorder;

import SALT.assessment.*;

/**
 * An input dialog to define a Design.
 * 
 */
public class DesignDialog extends Dialog implements ActionListener {

	private JTabbedPane TabbedPane;
	
	private JPanel tabAdditionalSubjectInfos;
	private JPanel tabFaderButton;
	private JPanel tabRatingTrialItem;
	private JPanel tabMIDIDevicesFolder;
	private JPanel tabMIDIDevices;
	private JPanel tabFolder;
	private JPanel tabTrial;
	private JPanel tabItem;
	private JPanel tabFader;
	private JPanel tabButton;
	private JPanel tabTimeSlice;
	private JPanel tabRating;
	private JPanel tabContinuousButton;
	
	JLabel numberOfFaderLabel;
	JLabel MIDIChannelNumberLabel;
    JLabel MIDITimeCodeInputLabel;
	JLabel MIDIInputLabel;
	JLabel MIDIOutputLabel;
//	JLabel trialLabel;  //Commented out - stian
//	JLabel itemLabel;   //Commented out - stian
	JLabel MIDIButtonNumberForwardLabel;
	JLabel MIDIButtonNumberBackwardLabel;
	JLabel MIDIButtonNumberContinuousLabel;
	JLabel MIDIDefaultValueLabel;
	JLabel MIDIControllerNumberOfFader;
    JLabel MIDIControllerNumberOfButton;
	JLabel AdditionalSubjectInfosLabel;
	JLabel targetFolderLabel;
	JLabel TimeSliceLabel;
	JLabel TotalTimeLabel;
	
	JTextField targetFolderTextField;

	JFileChooser folderFileChooser;
	
	JComboBox numberOfFaderComboBox;
	JComboBox MIDIChannelNumberComboBox;
    JComboBox MIDITimeCodeInputComboBox;
	JComboBox MIDIInputComboBox;
	JComboBox MIDIOutputComboBox;
//	JComboBox trialIDComboBox;  //Commented out - stian
//	JComboBox itemIDComboBox;   //Commented out - stian
	JComboBox MIDIButtonNumberForwardComboBox;
	JComboBox MIDIButtonNumberBackwardComboBox;
	JComboBox MIDIControllerNumberOfFaderComboBox;
    JComboBox MIDIControllerNumberOfButtonComboBox;     //Edit in - Stian
	JComboBox MIDIButtonNumberContinuousComboBox;

    //Commented out - stian
//	JButton buttonNewTrial;
//	JButton buttonEditTrial;
//	JButton buttonDeleteTrial;
//	JButton buttonNewItem;
//	JButton buttonEditItem;
//	JButton buttonDeleteItem;
	JButton buttonEditFader;
    JButton buttonEditButton;       //Edit in - Stian
	JButton buttonNewSubjectInfos;
	JButton buttonEditSubjectInfos;
	JButton buttonDeleteSubjectInfos;
	JButton buttontargetFolder;
	JButton buttonDeleteContinuousButton;
	JButton buttonNewContinuousButton;
	
	JRadioButton continuousFaderButton;
	JRadioButton continuousButtonButton;
	JRadioButton noncontinuousButton;
	ButtonGroup ratingRadioButtonGroup; 
	
//	TitledBorder trialTitle;
//	TitledBorder itemTitle;
	TitledBorder faderTitle;
	TitledBorder buttonTitle;
	TitledBorder midiTitle;
	TitledBorder folderTitle;
	TitledBorder additionalSubjectInfoTitle;
	TitledBorder continuousTitle;
	TitledBorder ratingTitle;
	TitledBorder timeSliceTitle;

    Vector<String> midiTimeCodeInputNames;
	Vector<String> midiInputNames;
	Vector<String> midiOutputNames;

	TrialItemDialog trialItemDialog;
	AdditionalSubjectInfoDialog additionalSubjectInfoDialog;
	FaderDialog faderDialog;
    ButtonDialog buttonDialog;
	ContinuousDialog continuousDialog;

	JFrame frame;

	Design design;

	JList additionalSubjectInfoList;
	DefaultListModel listModel;

	JScrollPane additionalSubjectInfoScroller;

    private List<MidiDevice.Info> midiTimeCodeInputInfoVector;
	private List<MidiDevice.Info> midiInputInfoVector;
	private List<MidiDevice.Info> midiOutputInfoVector;
	
	String[] MIDIButtonNumberForwardComboBoxItems = { "73", "72", "71",
			"70", "69", "68", "67", "66", "65", "64", "63", "62", "61",
			"60" };
	String[] MIDIButtonNumberBackwardComboBoxItems = { "73", "72", "71",
			"70", "69", "68", "67", "66", "65", "64", "63", "62", "61",
			"60" };
	
	JSpinner spinner;
	SpinnerNumberModel spinnerNumberModel;
	JSpinner timeSlicespinner;
	SpinnerNumberModel timeSlicespinnerNumberModel;
	JSpinner MIDIDefaultValueSpinner;
	SpinnerNumberModel MIDIDefaultValueSpinnerNumberModel;
	
	/**
	 * Constructs a DesignDialog.
	 * @param midiInputInfoVector
	 * @param midiOutputInfoVector
	 */
	public DesignDialog(List<MidiDevice.Info> midiInputInfoVector,
			List<MidiDevice.Info> midiOutputInfoVector, List<MidiDevice.Info> midiTimeCodeInputInfoVector) {

        this.midiTimeCodeInputInfoVector = midiTimeCodeInputInfoVector;
		this.midiInputInfoVector = midiInputInfoVector;
		this.midiOutputInfoVector = midiOutputInfoVector;
		
		listModel = new DefaultListModel();
		additionalSubjectInfoList = new JList(listModel);

		additionalSubjectInfoScroller = new JScrollPane(
				additionalSubjectInfoList);
		additionalSubjectInfoScroller.setPreferredSize(new Dimension(180, 135));

		spinnerNumberModel = new SpinnerNumberModel(30000, 100, 360000, 100);
		timeSlicespinnerNumberModel = new SpinnerNumberModel(10, 10, 10000, 10);
		MIDIDefaultValueSpinnerNumberModel = new SpinnerNumberModel(50,0,100,10);
		
		spinner = new JSpinner(spinnerNumberModel);		
		timeSlicespinner = new JSpinner(timeSlicespinnerNumberModel);		
		MIDIDefaultValueSpinner = new JSpinner(MIDIDefaultValueSpinnerNumberModel);	
					
		TabbedPane = new JTabbedPane();
		tabFaderButton = new JPanel(gridBagLayout);
		tabFader = new JPanel(gridBagLayout);
		tabButton = new JPanel(gridBagLayout);
		tabRatingTrialItem = new JPanel(gridBagLayout);
		tabTrial = new JPanel(gridBagLayout);
		tabItem = new JPanel(gridBagLayout);
		tabMIDIDevices = new JPanel(gridBagLayout);
		tabFolder = new JPanel(gridBagLayout);
		tabMIDIDevicesFolder = new JPanel(gridBagLayout);
		tabAdditionalSubjectInfos = new JPanel(gridBagLayout);
		tabContinuousButton = new JPanel(gridBagLayout);
		tabRating = new JPanel(gridBagLayout);
		tabTimeSlice = new JPanel(gridBagLayout);
		
		numberOfFaderLabel = new JLabel("Number of Faders");
		MIDIChannelNumberLabel = new JLabel("MIDI Channel Number");
		MIDIButtonNumberForwardLabel = new JLabel("MIDI Button Number Forward");
		MIDIButtonNumberBackwardLabel = new JLabel(
				"MIDI Button Number Backward");
		MIDIButtonNumberContinuousLabel = new JLabel("Button No(s).");
		MIDIDefaultValueLabel = new JLabel("MIDI Default Value");
        MIDITimeCodeInputLabel = new JLabel("MIDI Time Code Input");
		MIDIInputLabel = new JLabel("MIDI Input");
		MIDIOutputLabel = new JLabel("MIDI Output");
//		trialLabel = new JLabel("ID(s)");   //Commented out - stian
//		itemLabel = new JLabel("ID(s)");    //Commented out - stian
		MIDIControllerNumberOfFader = new JLabel(
				"MIDI Controller Number of Fader");
        MIDIControllerNumberOfButton = new JLabel(
                "MIDI Controller Number of Button");
		AdditionalSubjectInfosLabel = new JLabel("Subject Info List ");
		targetFolderLabel = new JLabel("Session Target Folder");
		TimeSliceLabel = new JLabel("Timeslice in msec");
		TotalTimeLabel = new JLabel("Duration of Sound File in msec");
		
		targetFolderTextField = new JTextField(28);
		targetFolderTextField.setEditable(false);
		
		trialItemDialog = new TrialItemDialog();
		additionalSubjectInfoDialog = new AdditionalSubjectInfoDialog();
		faderDialog = new FaderDialog();
        buttonDialog = new ButtonDialog();
		continuousDialog = new ContinuousDialog();
		
		folderFileChooser = new JFileChooser();
		folderFileChooser.setDialogTitle("Select Session Target Folder");
		folderFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        midiTimeCodeInputNames = new Vector<String>();
		midiInputNames = new Vector<String>();
		midiOutputNames = new Vector<String>();
		getMidiNames();

		String[] numberOfFaderComboBoxItems = { "1", "2", "3", "4", "5", "6",
				"7", "8" };
		String[] MIDIChannelNumberComboBoxItems = { "1", "2", "3", "4", "5",
				"6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16" };
		
		String[] trialIDComboBoxItems = {};
		String[] itemIDComboBoxItems = {};
		String[] MIDIDefaultValueComboBoxItems = { "0", "50", "100" };
		String[] MIDIControllerNumberOfFaderComboBoxItems = { "1" };
        String[] MIDIControllerNumberOfButtonComboBoxItems = { "1" };
		String[] MIDIButtonNumberContinuousComboBoxItems = {};

		numberOfFaderComboBox = new JComboBox(numberOfFaderComboBoxItems);
		MIDIChannelNumberComboBox = new JComboBox(
				MIDIChannelNumberComboBoxItems);
		MIDIButtonNumberForwardComboBox = new JComboBox(
				MIDIButtonNumberForwardComboBoxItems);
		MIDIButtonNumberBackwardComboBox = new JComboBox(
				MIDIButtonNumberBackwardComboBoxItems);
		MIDIButtonNumberContinuousComboBox = new JComboBox(
				MIDIButtonNumberContinuousComboBoxItems);

        MIDITimeCodeInputComboBox = new JComboBox(midiTimeCodeInputNames);
		MIDIInputComboBox = new JComboBox(midiInputNames);
		MIDIOutputComboBox = new JComboBox(midiOutputNames);
//		trialIDComboBox = new JComboBox(trialIDComboBoxItems);  //Commented out - stian
//		itemIDComboBox = new JComboBox(itemIDComboBoxItems);    //Commented out - stian
		MIDIControllerNumberOfFaderComboBox = new JComboBox(
				MIDIControllerNumberOfFaderComboBoxItems);

        //Edit in - Stian
        MIDIControllerNumberOfButtonComboBox = new JComboBox(
                MIDIControllerNumberOfButtonComboBoxItems);
		
		MIDIButtonNumberForwardComboBox.setSelectedItem("73");
		MIDIButtonNumberBackwardComboBox.setSelectedItem("72");
		
		numberOfFaderComboBox.setActionCommand("NUMBEROFFADER");
		numberOfFaderComboBox.addActionListener(this);
        MIDITimeCodeInputComboBox.setActionCommand("MIDITIMECODEINPUT");
        MIDITimeCodeInputComboBox.addActionListener(this);
		MIDIInputComboBox.setActionCommand("MIDIINPUT");
		MIDIInputComboBox.addActionListener(this);
		MIDIOutputComboBox.setActionCommand("MIDIOUTPUT");
		MIDIOutputComboBox.addActionListener(this);
		MIDIButtonNumberForwardComboBox.setActionCommand("MIDIButtonNumberForward");
		MIDIButtonNumberForwardComboBox.addActionListener(this);
		MIDIButtonNumberBackwardComboBox.setActionCommand("MIDIButtonNumberBackward");
		MIDIButtonNumberBackwardComboBox.addActionListener(this);


        /*
         *
         * Modified to warn user
         * Later commented out
         * Stian
         * */
//		trialTitle = BorderFactory.createTitledBorder("Trial - use main interface");
//		itemTitle = BorderFactory.createTitledBorder("Item - use main interface");
//      trialTitle = BorderFactory.createTitledBorder("Trial");
//		itemTitle = BorderFactory.createTitledBorder("Item");
        /*
         * End of edit
         * Stian
         * */

		faderTitle = BorderFactory.createTitledBorder("Fader");
		buttonTitle = BorderFactory.createTitledBorder("Button");
		midiTitle = BorderFactory.createTitledBorder("MIDI Devices");
		folderTitle = BorderFactory.createTitledBorder("Folder");
		additionalSubjectInfoTitle = BorderFactory.createTitledBorder("Additional Subject Infos");
		continuousTitle = BorderFactory.createTitledBorder("Continuous Rating (Button)");
		ratingTitle = BorderFactory.createTitledBorder("Rating");
		timeSliceTitle = BorderFactory.createTitledBorder("Continuous Rating (Fader)");

//		tabTrial.setBorder(trialTitle);
//		tabItem.setBorder(itemTitle);
		tabFader.setBorder(faderTitle);
		tabButton.setBorder(buttonTitle);
		tabMIDIDevices.setBorder(midiTitle);
		tabFolder.setBorder(folderTitle);
		tabAdditionalSubjectInfos.setBorder(additionalSubjectInfoTitle);
		tabContinuousButton.setBorder(continuousTitle);
		tabRating.setBorder(ratingTitle);
		tabTimeSlice.setBorder(timeSliceTitle);	

        //Commented out - stian
//		buttonNewTrial = makeButton("NEWTRIAL", "New", this);
//		buttonEditTrial = makeButton("EDITTRIAL", "Edit", this);
//		buttonDeleteTrial = makeButton("DELETETRIAL", "Delete", this);
//		buttonNewItem = makeButton("NEWITEM", "New", this);
//		buttonEditItem = makeButton("EDITITEM", "Edit", this);
//		buttonDeleteItem = makeButton("DELETEITEM", "Delete", this);
		buttonEditFader = makeButton("EDITFADER", "Edit", this);
        buttonEditButton = makeButton("EDITBUTTON", "Edit", this);      //Edit in - Stian
		buttonNewSubjectInfos = makeButton("NEWSUBJECTINFOS", "New", this);
		buttonEditSubjectInfos = makeButton("EDITSUBJECTINFOS", "Edit", this);
		buttonDeleteSubjectInfos = makeButton("DELETESUBJECTINFOS", "Delete",
				this);
		buttontargetFolder = makeButton("FOLDER", "...", this);
		buttonDeleteContinuousButton = makeButton("DELETECONTINUOUSBUTTON", "Delete", this);
		buttonNewContinuousButton = makeButton("NEWCONTINUOUSBUTTON", "New", this);

        //Commented out stian
//		buttonEditTrial.setEnabled(false);
//		buttonDeleteTrial.setEnabled(false);
//		buttonEditItem.setEnabled(false);
//		buttonDeleteItem.setEnabled(false);
		buttonEditSubjectInfos.setEnabled(false);
		buttonDeleteSubjectInfos.setEnabled(false);
		buttonDeleteContinuousButton.setEnabled(false);
		buttonNewContinuousButton.setEnabled(false);
		spinner.setEnabled(false);
		timeSlicespinner.setEnabled(false);
		
		noncontinuousButton = new JRadioButton("Noncontinuous Rating");
		continuousFaderButton = new JRadioButton("Continuous Rating (Fader)");
		continuousButtonButton = new JRadioButton("Continuous Rating (Button)");
					
		ratingRadioButtonGroup = new ButtonGroup();		
		ratingRadioButtonGroup.add(noncontinuousButton);
		ratingRadioButtonGroup.add(continuousFaderButton);
		ratingRadioButtonGroup.add(continuousButtonButton);
				
		continuousFaderButton.setActionCommand("CONTINUOUSFADER");
		continuousFaderButton.addActionListener(this);
		continuousButtonButton.setActionCommand("CONTINUOUSBUTTON");
		continuousButtonButton.addActionListener(this);
		noncontinuousButton.setActionCommand("NONCONTINUOUS");
		noncontinuousButton.addActionListener(this);

		// tabMIDIDevices
        makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDITimeCodeInputLabel, gridBagConstraints);
		tabMIDIDevices.add(MIDITimeCodeInputLabel);

        makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDITimeCodeInputComboBox, gridBagConstraints);
		tabMIDIDevices.add(MIDITimeCodeInputComboBox);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIInputLabel, gridBagConstraints);
		tabMIDIDevices.add(MIDIInputLabel);

		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIInputComboBox, gridBagConstraints);
		tabMIDIDevices.add(MIDIInputComboBox);

		makeGridBagConstraints(0, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIOutputLabel, gridBagConstraints);
		tabMIDIDevices.add(MIDIOutputLabel);

		makeGridBagConstraints(1, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIOutputComboBox, gridBagConstraints);
		tabMIDIDevices.add(MIDIOutputComboBox);

		// tabFolder
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(targetFolderLabel, gridBagConstraints);
		tabFolder.add(targetFolderLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(targetFolderTextField, gridBagConstraints);
		tabFolder.add(targetFolderTextField);

		makeGridBagConstraints(2, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttontargetFolder, gridBagConstraints);
		tabFolder.add(buttontargetFolder);

		// tabMIDIDevicesFolder
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabMIDIDevices, gridBagConstraints);
		tabMIDIDevicesFolder.add(tabMIDIDevices);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabFolder, gridBagConstraints);
		tabMIDIDevicesFolder.add(tabFolder);

		// tabTrial - commented out stian
//		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(trialLabel, gridBagConstraints);
//		tabTrial.add(trialLabel);

        //Commented out - stian
//		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(trialIDComboBox, gridBagConstraints);
//		tabTrial.add(trialIDComboBox);

//		makeGridBagConstraints(2, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonNewTrial, gridBagConstraints);
//		tabTrial.add(buttonNewTrial);
//
//		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonEditTrial, gridBagConstraints);
//		tabTrial.add(buttonEditTrial);
//
//		makeGridBagConstraints(2, 1, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonDeleteTrial, gridBagConstraints);
//		tabTrial.add(buttonDeleteTrial);

		// tabItem - commented out - stian
//		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(itemLabel, gridBagConstraints);
//		tabItem.add(itemLabel);

        //Commented out - stian
//		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(itemIDComboBox, gridBagConstraints);
//		tabItem.add(itemIDComboBox);
//
//		makeGridBagConstraints(2, 0, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonNewItem, gridBagConstraints);
//		tabItem.add(buttonNewItem);
//
//		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonEditItem, gridBagConstraints);
//		tabItem.add(buttonEditItem);
//
//		makeGridBagConstraints(2, 1, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(buttonDeleteItem, gridBagConstraints);
//		tabItem.add(buttonDeleteItem);

		// tabTimeSlice		
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(TimeSliceLabel,
				gridBagConstraints);
		tabTimeSlice.add(TimeSliceLabel);		

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(timeSlicespinner,
				gridBagConstraints);
		tabTimeSlice.add(timeSlicespinner);
				
		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(TotalTimeLabel,
				gridBagConstraints);
		tabTimeSlice.add(TotalTimeLabel);
		
		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(spinner,
				gridBagConstraints);
		tabTimeSlice.add(spinner);		
		
		// tabContinuousButton
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberContinuousLabel,
				gridBagConstraints);
		tabContinuousButton.add(MIDIButtonNumberContinuousLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberContinuousComboBox,
				gridBagConstraints);
		tabContinuousButton.add(MIDIButtonNumberContinuousComboBox);
		
		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonDeleteContinuousButton,
				gridBagConstraints);
		tabContinuousButton.add(buttonDeleteContinuousButton);
		
		makeGridBagConstraints(2, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonNewContinuousButton,
				gridBagConstraints);
		tabContinuousButton.add(buttonNewContinuousButton);
	
		// tabRating
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(noncontinuousButton, gridBagConstraints);
		tabRating.add(noncontinuousButton);
		
		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(continuousFaderButton, gridBagConstraints);
		tabRating.add(continuousFaderButton);
		
		makeGridBagConstraints(0, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(continuousButtonButton, gridBagConstraints);
		tabRating.add(continuousButtonButton);
		
		// tabRatingTrialItem
		makeGridBagConstraints(0, 0, 1, 2, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabRating, gridBagConstraints);
		tabRatingTrialItem.add(tabRating);
		
		makeGridBagConstraints(0, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabTrial, gridBagConstraints);
		tabRatingTrialItem.add(tabTrial);

		makeGridBagConstraints(1, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabItem, gridBagConstraints);
		tabRatingTrialItem.add(tabItem);
		
		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabTimeSlice, gridBagConstraints);
		tabRatingTrialItem.add(tabTimeSlice);
		
		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabContinuousButton, gridBagConstraints);
		tabRatingTrialItem.add(tabContinuousButton);
		
		// tabFader
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(numberOfFaderLabel, gridBagConstraints);
		tabFader.add(numberOfFaderLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(numberOfFaderComboBox, gridBagConstraints);
		tabFader.add(numberOfFaderComboBox);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIControllerNumberOfFader,
				gridBagConstraints);
		tabFader.add(MIDIControllerNumberOfFader);

		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIControllerNumberOfFaderComboBox,
				gridBagConstraints);
		tabFader.add(MIDIControllerNumberOfFaderComboBox);

		makeGridBagConstraints(2, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonEditFader, gridBagConstraints);
		tabFader.add(buttonEditFader);

        /*
         * Edited in another combobox to set midi control for fader buttons
         * Stian
         * */

        makeGridBagConstraints(0, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIControllerNumberOfButton,
				gridBagConstraints);
		tabFader.add(MIDIControllerNumberOfButton);
        makeGridBagConstraints(1, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIControllerNumberOfButtonComboBox,
				gridBagConstraints);
		tabFader.add(MIDIControllerNumberOfButtonComboBox);
        makeGridBagConstraints(2, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonEditButton, gridBagConstraints);
		tabFader.add(buttonEditButton);

        /*
         * End of edit
         * Stian
         * */

		makeGridBagConstraints(0, 3, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout
				.setConstraints(MIDIChannelNumberLabel, gridBagConstraints);
		tabFader.add(MIDIChannelNumberLabel);

		makeGridBagConstraints(1, 3, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIChannelNumberComboBox,
				gridBagConstraints);
		tabFader.add(MIDIChannelNumberComboBox);
//        makeGridBagConstraints(1, 2, 1, 1, gridBagConstraints);
//		gridBagConstraints.anchor = GridBagConstraints.WEST;
//		gridBagLayout.setConstraints(MIDIControllerNumberOfButtonComboBox,
//				gridBagConstraints);
//		tabFader.add(MIDIControllerNumberOfButtonComboBox);

		makeGridBagConstraints(0, 4, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIDefaultValueLabel, gridBagConstraints);
		tabFader.add(MIDIDefaultValueLabel);

		makeGridBagConstraints(1, 4, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIDefaultValueSpinner,
				gridBagConstraints);
		tabFader.add(MIDIDefaultValueSpinner);

		// tabButton
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberForwardLabel,
				gridBagConstraints);
		tabButton.add(MIDIButtonNumberForwardLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberForwardComboBox,
				gridBagConstraints);
		tabButton.add(MIDIButtonNumberForwardComboBox);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberBackwardLabel,
				gridBagConstraints);
		tabButton.add(MIDIButtonNumberBackwardLabel);

		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(MIDIButtonNumberBackwardComboBox,
				gridBagConstraints);
		tabButton.add(MIDIButtonNumberBackwardComboBox);

		// tabFaderButton
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabFader, gridBagConstraints);
		tabFaderButton.add(tabFader);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(tabButton, gridBagConstraints);
		tabFaderButton.add(tabButton);

		// tabAdditionalSubjectInfos
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(AdditionalSubjectInfosLabel,
				gridBagConstraints);
		tabAdditionalSubjectInfos.add(AdditionalSubjectInfosLabel);

		makeGridBagConstraints(0, 1, 1, 4, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(additionalSubjectInfoScroller,
				gridBagConstraints);
		tabAdditionalSubjectInfos.add(additionalSubjectInfoScroller);

		makeGridBagConstraints(1, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonNewSubjectInfos, gridBagConstraints);
		tabAdditionalSubjectInfos.add(buttonNewSubjectInfos);

		makeGridBagConstraints(1, 2, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout
				.setConstraints(buttonEditSubjectInfos, gridBagConstraints);
		tabAdditionalSubjectInfos.add(buttonEditSubjectInfos);

		makeGridBagConstraints(1, 3, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(buttonDeleteSubjectInfos,
				gridBagConstraints);
		tabAdditionalSubjectInfos.add(buttonDeleteSubjectInfos);

		TabbedPane.addTab("Additional Subject Infos", tabAdditionalSubjectInfos);
		TabbedPane.addTab("Rating | Trial | Item", tabRatingTrialItem);
		TabbedPane.addTab("Fader | Button", tabFaderButton);
		TabbedPane.addTab("MIDIDevices | Folder", tabMIDIDevicesFolder);

		TabbedPane.setSelectedComponent(tabAdditionalSubjectInfos);
		dialogPanel.add(TabbedPane);


        /*
         * Disabling components that are controlled in main interface
         * Commented out
         * Stian
         * */
//        buttonNewTrial.setEnabled(false);
//		buttonEditTrial.setEnabled(false);
//		buttonDeleteTrial.setEnabled(false);
//		buttonNewItem.setEnabled(false);
//		buttonEditItem.setEnabled(false);
//		buttonDeleteItem.setEnabled(false);
//      trialIDComboBox.setEnabled(false);
//      itemIDComboBox.setEnabled(false);
	}

	/**
	 * Adds MIDI input devices and MIDI output devices to vectors.
	 */
	private void getMidiNames() {

        midiTimeCodeInputNames.add("Not Enabled");
		midiInputNames.add("Not Enabled");
		midiOutputNames.add("Not Enabled");

        for (int i = 0; i < midiTimeCodeInputInfoVector.size(); i++) {
            midiTimeCodeInputNames.add(midiTimeCodeInputInfoVector.get(i).getName());
        }
		for (int i = 0; i < midiInputInfoVector.size(); i++) {
			midiInputNames.add(midiInputInfoVector.get(i).getName());
		}
		for (int i = 0; i < midiOutputInfoVector.size(); i++) {
			midiOutputNames.add(midiOutputInfoVector.get(i).getName());
		}
		
		/*
		 private void getMidiNames() {
		
		MidiDevice.Info[] infos = MidiSystem.getMidiDeviceInfo();

		midiInputNames.add("Not Enabled");
		midiOutputNames.add("Not Enabled");

		for (int i = 0; i < infos.length; i++) {
			try {
				MidiDevice device = MidiSystem.getMidiDevice(infos[i]);

				// MIDI-Ausg�nge
				if (device.getMaxReceivers() != 0) {
					midiOutputNames.add(infos[i].getName());
				}

				// MIDI-Eing�nge
				if (device.getMaxTransmitters() != 0) {
					midiInputNames.add(infos[i].getName());
				}
			} 
			catch (Exception e) {
				//TODO
			}
		}		
	}
		 */
	}

	/**
     *
	 * Displays the DesignDialog.
	 * @param frame
	 * @param design
	 * @return
	 */
	public boolean display(JFrame frame, Design design, boolean edit) {

		this.design = design;
		this.frame = frame;
		boolean b = false;
		
		if(edit == false){
			targetFolderTextField.setText("Not Selected");

			MIDIChannelNumberComboBox.setSelectedItem("1");
			MIDIDefaultValueSpinner.setValue(50);
			MIDIButtonNumberForwardComboBox.setSelectedItem("73");
			MIDIButtonNumberBackwardComboBox.setSelectedItem("72");
            MIDITimeCodeInputComboBox.setSelectedItem("Not Enabled");
			MIDIInputComboBox.setSelectedItem("Not Enabled");
			MIDIOutputComboBox.setSelectedItem("Not Enabled");
			
			noncontinuousButton.setSelected(true);
			continuousFaderButton.setSelected(false);
			continuousButtonButton.setSelected(false);
		
			MIDIButtonNumberContinuousComboBox.setEnabled(false);
		}
		
		if(edit == false){
		
		boolean missingInputs = true;

		while (missingInputs == true) {
			missingInputs = false;
			int choosedOption = JOptionPane.showOptionDialog(frame,
					dialogPanel, "New Design", JOptionPane.DEFAULT_OPTION,
					JOptionPane.PLAIN_MESSAGE, null, options, options[1]);

            /*
             * Added to fix small bug
             * Stian
             * */
            if (choosedOption==1) {
                b = false;
            }
            /*
             * End of add
             * Stian
             * */
			// OK selected
			if (choosedOption == 0) {
				String warningString = new String();
                /*
                 * Edited out to allow not selected trials and items
                 * Stian
                 * */
//				if (trialIDComboBox.getSelectedItem() == null) {
//					warningString = warningString + "Trials\n";
//					missingInputs = true;
//				}
//				if (itemIDComboBox.getSelectedItem() == null && (noncontinuousButton.isSelected() ||
//						continuousFaderButton.isSelected())) {
//					warningString = warningString + "Items\n";
//					missingInputs = true;
//				}
                /*
                 * End of edit
                 * Stian
                 * */

                if(MIDITimeCodeInputComboBox.getSelectedIndex() == 0) {
                    warningString = warningString + "MIDI Time Code Input\n";
                    missingInputs = true;
                }

				if (MIDIInputComboBox.getSelectedIndex() == 0) {
					warningString = warningString + "MIDI Input\n";
					missingInputs = true;
				}
				if (MIDIOutputComboBox.getSelectedIndex() == 0) {
					warningString = warningString + "MIDI Output\n";
					missingInputs = true;
				}
				if (targetFolderTextField.getText().equals("Not Selected") == true) {
					warningString = warningString + "Session Target Folder\n";
					missingInputs = true;
				}
				if (missingInputs == true) {
                    JOptionPane.showMessageDialog(frame, "Please select: \n"
							+ warningString, "Warning!",
							JOptionPane.ERROR_MESSAGE);
                    b = false;
                }

				design.setNumberOfFaders(Integer
						.valueOf((String) numberOfFaderComboBox
								.getSelectedItem()));

				design.setMIDIChannelNumber(Integer
						.valueOf((String) MIDIChannelNumberComboBox
								.getSelectedItem()));
				design.setMIDIDefaultValue(Integer
						.valueOf(String.valueOf(MIDIDefaultValueSpinner.getValue()
								)));
				design.setMIDIButtonNumberForward(Integer
						.valueOf((String) MIDIButtonNumberForwardComboBox
								.getSelectedItem()));
				design.setMIDIButtonNumberBackward(Integer
						.valueOf((String) MIDIButtonNumberBackwardComboBox
								.getSelectedItem()));

                design.setTimeCodeInputDevice(MIDITimeCodeInputComboBox.getSelectedIndex() - 1);
				design.setInputDevice(MIDIInputComboBox.getSelectedIndex() - 1);
				design.setOutputDevice(MIDIOutputComboBox.getSelectedIndex() - 1);

				design.setTargetFolder(targetFolderTextField.getText());
				
				if (noncontinuousButton.isSelected()){
					design.setContinuousButton(false);
					design.setContinuousFader(false);
				}
				if (continuousButtonButton.isSelected()){
					design.setContinuousButton(true);
					design.setContinuousFader(false);
				}
				if (continuousFaderButton.isSelected()){
					design.setContinuousButton(false);
					design.setContinuousFader(true);
					design.setTimeSlice(Float.valueOf(String.valueOf(timeSlicespinner.getValue())));				
					design.setTotalTime(Float.valueOf(String.valueOf(spinner.getValue())));
				}				
				b = true;
			}
		}
		}
			
			if(edit){
			List<String> additionalSubjectInfosList = design.getAdditionalSubjectInfos();
			for (String additionalSubjectInfo : additionalSubjectInfosList) {
				listModel.addElement(additionalSubjectInfo);
			}

            /*
             * commented out - stian
             * not necessary since trials and their items are no longer directly connected to the design class
             * stian
             * */
//			HashMap<Integer,String> itemHashMap = design.getItemIDandName();
//			Set<Integer> itemKeysSet = itemHashMap.keySet();
//			Integer itemkey = new Integer(0);
//
//			for (Iterator<Integer> iterator = itemKeysSet.iterator(); iterator.hasNext()==true;) {
//				itemkey = iterator.next();
//				String id =  String.valueOf((Integer)itemkey);
//				String name = itemHashMap.get((Integer)itemkey);
//				itemIDComboBox.addItem(id);
//			}
//
//			HashMap<Integer,String> trialHashMap = design.getTrialIDandName();
//			Set<Integer> trialKeysSet = trialHashMap.keySet();
//			Integer trialkey = new Integer(0);
//
//			for (Iterator<Integer> iterator = trialKeysSet.iterator(); iterator.hasNext()==true;) {
//				trialkey = iterator.next();
//				String id =  String.valueOf((Integer)trialkey);
//				String name = trialHashMap.get((Integer)trialkey);
//				trialIDComboBox.addItem(id);
//			}
			
			targetFolderTextField.setText(design.getTargetFolder());
			
			numberOfFaderComboBox.setSelectedItem(String.valueOf(design.getNumberOfFaders()));
			MIDIChannelNumberComboBox.setSelectedItem(String.valueOf(design.getMIDIChannelNumber()));
			MIDIDefaultValueSpinner.setValue(design.getMIDIDefaultValue());
			MIDIButtonNumberForwardComboBox.setSelectedItem(String.valueOf(design.getMIDIButtonNumberForward()));
			MIDIButtonNumberBackwardComboBox.setSelectedItem(String.valueOf(design.getMIDIButtonNumberBackward()));

            MIDITimeCodeInputComboBox.setSelectedItem(midiInputNames.get(design.getTimeCodeInputDevice()+1));
			MIDIInputComboBox.setSelectedItem(midiInputNames.get(design.getInputDevice()+1));
			MIDIOutputComboBox.setSelectedItem(midiOutputNames.get(design.getOutputDevice()+1));
			timeSlicespinner.setValue(design.getTimeSlice());
			spinner.setValue(design.getTotalTime());
			
			if(design.isContinuousButton() == false && design.isContinuousFader() == false){
				noncontinuousButton.setSelected(true);
				timeSlicespinner.setEnabled(false);
				MIDIButtonNumberContinuousComboBox.setEnabled(false);
                //Commented out - stian
//				buttonNewItem.setEnabled(true);
//				buttonEditItem.setEnabled(true);
//				buttonDeleteItem.setEnabled(true);
//				itemIDComboBox.setEnabled(true);
			}		
			
			if(design.isContinuousButton() == true && design.isContinuousFader() == false){
				continuousButtonButton.setSelected(true);
				timeSlicespinner.setEnabled(false);
				MIDIButtonNumberContinuousComboBox.setEnabled(true);
                //Commented out - stian
//				buttonNewItem.setEnabled(true);
//				buttonEditItem.setEnabled(true);
//				buttonDeleteItem.setEnabled(true);
//				itemIDComboBox.setEnabled(true);
			}
			
			if(design.isContinuousButton() == false && design.isContinuousFader() == true){
				continuousFaderButton.setSelected(true);
				timeSlicespinner.setEnabled(true);
				MIDIButtonNumberContinuousComboBox.setEnabled(false);
                //Commented out - stian
//				buttonNewItem.setEnabled(true);
//				buttonEditItem.setEnabled(true);
//				buttonDeleteItem.setEnabled(true);
//				itemIDComboBox.setEnabled(true);
			}	
		
			int choosedOption = JOptionPane.showOptionDialog(frame, dialogPanel, "Edit Design",
				JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE, null, options,
				options[1]);

			if (choosedOption == 0){
				design.setNumberOfFaders(Integer.valueOf((String)numberOfFaderComboBox.getSelectedItem()));
			
				design.setMIDIChannelNumber(Integer.valueOf((String)MIDIChannelNumberComboBox.getSelectedItem()));
				design.setMIDIDefaultValue(Integer.valueOf(String.valueOf(MIDIDefaultValueSpinner.getValue())));
				design.setMIDIButtonNumberForward(Integer.valueOf((String)MIDIButtonNumberForwardComboBox.getSelectedItem()));
				design.setMIDIButtonNumberBackward(Integer.valueOf((String)MIDIButtonNumberBackwardComboBox.getSelectedItem()));

                design.setTimeCodeInputDevice(MIDITimeCodeInputComboBox.getSelectedIndex()-1);
				design.setInputDevice(MIDIInputComboBox.getSelectedIndex()-1);
				design.setOutputDevice(MIDIOutputComboBox.getSelectedIndex()-1);
			
				design.setTargetFolder(targetFolderTextField.getText());
											
				if (noncontinuousButton.isSelected()){
					design.setContinuousButton(false);
					design.setContinuousFader(false);
				}
				if (continuousButtonButton.isSelected()){
					design.setContinuousButton(true);
					design.setContinuousFader(false);
				}
				if (continuousFaderButton.isSelected()){
					design.setContinuousButton(false);
					design.setContinuousFader(true);

					design.setTimeSlice(Float.valueOf((String)timeSlicespinner.getValue()));
					design.setTotalTime(Float.valueOf((String)spinner.getValue()));
				}				
				b = true;
			}
			}
		
		TabbedPane.setSelectedComponent(tabAdditionalSubjectInfos);

		listModel.clear();

        //Commented out - stian
//		trialIDComboBox.removeAllItems();
//		itemIDComboBox.removeAllItems();

		numberOfFaderComboBox.setSelectedItem("1");
		MIDIChannelNumberComboBox.setSelectedItem("1");
		MIDIDefaultValueSpinner.setValue(50);
		MIDIButtonNumberForwardComboBox.setSelectedItem("73");
		MIDIButtonNumberBackwardComboBox.setSelectedItem("72");

        MIDITimeCodeInputComboBox.setSelectedItem("Not Enabled");
		MIDIInputComboBox.setSelectedItem("Not Enabled");
		MIDIOutputComboBox.setSelectedItem("Not Enabled");
		targetFolderTextField.setText("Not Selected");
		
		noncontinuousButton.setSelected(true);
		continuousFaderButton.setSelected(false);
		continuousButtonButton.setSelected(false);
		
		timeSlicespinner.setEnabled(false);
		spinner.setEnabled(false);
		MIDIButtonNumberContinuousComboBox.setEnabled(false);

        //Commented out - stian
//		buttonNewItem.setEnabled(true);
//		buttonEditItem.setEnabled(true);
//		buttonDeleteItem.setEnabled(true);
//		itemIDComboBox.setEnabled(true);
		
		return b;
	}

	/** 
	 * Invokes when an action occurs.
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent event) {

		String cmd = event.getActionCommand();

		if (cmd.equals("NEWTRIAL")) {
			String ID = trialItemDialog.display(frame, design, 0, "Trial");
            //Commented out - stian
//			if (ID.length() != 0){
//				trialIDComboBox.addItem(ID);
//				buttonEditTrial.setEnabled(true);
//				buttonDeleteTrial.setEnabled(true);
//			}
		}
		if (cmd.equals("NEWITEM")) {
			String ID = trialItemDialog.display(frame, design, 0, "Item");
            //Commented out - stian
//			if (ID.length() != 0){
//				itemIDComboBox.addItem(ID);
//				buttonEditItem.setEnabled(true);
//				buttonDeleteItem.setEnabled(true);
//			}
		}
		if (cmd.equals("NEWSUBJECTINFOS")) {
			String meaning = additionalSubjectInfoDialog.display(frame, design,
					"", "New Subject Info");
			if (meaning.length() != 0){
				listModel.addElement(meaning);
				buttonEditSubjectInfos.setEnabled(true);
				buttonDeleteSubjectInfos.setEnabled(true);
			}
		}
        //Commented out - stian
//		if (cmd.equals("EDITTRIAL")) {
//			String ID = trialItemDialog.display(frame, design, Integer
//					.valueOf((String) trialIDComboBox.getSelectedItem()),
//					"Trial");
//			trialIDComboBox.removeItem(trialIDComboBox.getSelectedItem());
//			if (ID.length() != 0)
//				trialIDComboBox.addItem(ID);
//		}
		if (cmd.equals("EDITFADER")) {
			faderDialog.display(frame, design, Integer
					.valueOf(MIDIControllerNumberOfFaderComboBox
							.getSelectedItem().toString()));
		}
        if (cmd.equals("EDITBUTTON")) {
            buttonDialog.display(frame, design, Integer
                    .valueOf(MIDIControllerNumberOfButtonComboBox.getSelectedItem().toString()));
        }
        //Commented out - stian
//		if (cmd.equals("EDITITEM")) {
//			String ID = trialItemDialog
//					.display(frame, design,
//							Integer.valueOf((String) itemIDComboBox
//									.getSelectedItem()), "Item");
//			itemIDComboBox.removeItem(itemIDComboBox.getSelectedItem());
//			if (ID.length() != 0)
//				itemIDComboBox.addItem(ID);
//		}
		if (cmd.equals("EDITSUBJECTINFOS")) {
			if((String)additionalSubjectInfoList.getSelectedValue()!=null){
			String meaning = additionalSubjectInfoDialog.display(frame, design,
					(String) additionalSubjectInfoList.getSelectedValue(),
					"Edit Subject Info");
			listModel.removeElement(additionalSubjectInfoList
					.getSelectedValue());
			if (meaning.length() != 0)
				listModel.addElement(meaning);
			}
			else{
				JOptionPane.showMessageDialog(frame,
						"Please choose a list entry!",
						"Warning!", JOptionPane.ERROR_MESSAGE);
			}
			
		}
        //Commented out - stian
//		if (cmd.equals("DELETETRIAL")) {
//			trialIDComboBox.removeItem(trialIDComboBox.getSelectedItem());
//			if(trialIDComboBox.getItemCount()==0){
//				buttonEditTrial.setEnabled(false);
//				buttonDeleteTrial.setEnabled(false);
//			}
//		}
        //Commented out - stian
//		if (cmd.equals("DELETEITEM")) {
//			itemIDComboBox.removeItem(itemIDComboBox.getSelectedItem());
//			if(itemIDComboBox.getItemCount()==0){
//				buttonEditItem.setEnabled(false);
//				buttonDeleteItem.setEnabled(false);
//			}
//		}
		if (cmd.equals("DELETESUBJECTINFOS")) {
			if((String)additionalSubjectInfoList.getSelectedValue()!=null){
				listModel.removeElement(additionalSubjectInfoList
					.getSelectedValue());
				if(listModel.getSize()==0){
					buttonEditSubjectInfos.setEnabled(false);
					buttonDeleteSubjectInfos.setEnabled(false);
				}
			}
			else{
				JOptionPane.showMessageDialog(frame,
						"Please choose a list entry!",
						"Warning!", JOptionPane.ERROR_MESSAGE);
			}
		}
		if (cmd.equals("DELETECONTINUOUSBUTTON")) {
			MIDIButtonNumberContinuousComboBox.removeItem(MIDIButtonNumberContinuousComboBox.getSelectedItem());
			if(MIDIButtonNumberContinuousComboBox.getItemCount()==0){
				buttonDeleteContinuousButton.setEnabled(false);
			}
		}
		
		if (cmd.equals("NEWCONTINUOUSBUTTON")) {
			String ID = continuousDialog.display(frame, design, MIDIButtonNumberForwardComboBox,
					MIDIButtonNumberBackwardComboBox, MIDIButtonNumberContinuousComboBox);
			if (ID.length() != 0){
				design.addMIDIButtonNumberContinuous(Integer.valueOf(ID));
				MIDIButtonNumberContinuousComboBox.addItem(ID);
				buttonDeleteContinuousButton.setEnabled(true);
			}
		}
		
		if (cmd.equals("FOLDER")) {
			int choosedOption = folderFileChooser
					.showDialog(frame, "Ausw�hlen");
			if (choosedOption == JFileChooser.APPROVE_OPTION) {
				targetFolderTextField.setText(folderFileChooser
						.getSelectedFile().getPath());
			}
		}
		if (cmd.equals("NUMBEROFFADER")) {
			if (!numberOfFaderComboBox.getSelectedItem().toString().matches("1")){  //Fixed string-compare - Stian
                MIDIControllerNumberOfFaderComboBox.removeAllItems();
                MIDIControllerNumberOfButtonComboBox.removeAllItems();      //Edit in - Stian
                int number = Integer.valueOf((String) numberOfFaderComboBox.getSelectedItem());
                design.clearMIDIControllerNumberOfFaders();
                design.clearMIDIControllerNumberOfButtons();    //Edited in - Stian
                for (int i = 0; i < number; i++) {
                    MIDIControllerNumberOfFaderComboBox.addItem(i + 1);
                    MIDIControllerNumberOfButtonComboBox.addItem(i + 1);
                    design.addMIDIControllerNumberOfFader(21 + i);
                    design.addMIDIControllerNumberOfButton(31 + i);     //Edit in - Stian
                }
			}
		}

        if(cmd.equals("MIDITIMECODEINPUT")) {
            if (MIDITimeCodeInputComboBox.getSelectedIndex() > 0) {
				MidiDevice device;
				try {
					device = MidiSystem.getMidiDevice(midiInputInfoVector
							.get(MIDITimeCodeInputComboBox.getSelectedIndex() - 1));

					device.open();
				} catch (MidiUnavailableException e) {
					JOptionPane.showMessageDialog(frame,
							"Midi Input Device already used! \n",
							"Warning!", JOptionPane.ERROR_MESSAGE);
					MIDIInputComboBox.setSelectedIndex(0);
				}
			}
        }

		if (cmd.equals("MIDIINPUT")) {
			if (MIDIInputComboBox.getSelectedIndex() > 0) {
				MidiDevice device;
				try {
					device = MidiSystem.getMidiDevice(midiInputInfoVector
							.get(MIDIInputComboBox.getSelectedIndex() - 1));
					
					device.open();
				} catch (MidiUnavailableException e) {
					JOptionPane.showMessageDialog(frame,
							"Midi Input Device already used! \n",
							"Warning!", JOptionPane.ERROR_MESSAGE);
					MIDIInputComboBox.setSelectedIndex(0);
				}
			}
		}

		if (cmd.equals("MIDIOUTPUT")) {
			if (MIDIOutputComboBox.getSelectedIndex() > 0) {
				MidiDevice device;
				try {
					device = MidiSystem.getMidiDevice(midiOutputInfoVector
							.get(MIDIOutputComboBox.getSelectedIndex() - 1));

					device.open();
				
				} catch (MidiUnavailableException e) {
					JOptionPane.showMessageDialog(frame,
							"Midi Output Device already used! \n",
							"Warning!", JOptionPane.ERROR_MESSAGE);
					MIDIOutputComboBox.setSelectedIndex(0);
				}
			}
		}
		
		if (cmd.equals("NONCONTINUOUS")) {
			timeSlicespinner.setEnabled(false);
			MIDIButtonNumberContinuousComboBox.setEnabled(false);
            //Commented out - stian
//			buttonNewItem.setEnabled(true);
//			buttonEditItem.setEnabled(false);
//			buttonDeleteItem.setEnabled(false);
//			itemIDComboBox.setEnabled(true);
//			buttonEditTrial.setEnabled(false);
//			buttonDeleteTrial.setEnabled(false);
			spinner.setEnabled(false);
//			trialIDComboBox.removeAllItems();   //Commented out - stian
//			itemIDComboBox.removeAllItems();    //Commented out - stian
			MIDIButtonNumberContinuousComboBox.setSelectedItem("71");
			buttonNewContinuousButton.setEnabled(false);
			buttonDeleteContinuousButton.setEnabled(false);
		}
		
		if (cmd.equals("CONTINUOUSBUTTON")) {
			timeSlicespinner.setEnabled(false);
			MIDIButtonNumberContinuousComboBox.setEnabled(true);
            //Commented out - stian
//			buttonNewItem.setEnabled(true);
//			buttonEditItem.setEnabled(false);
//			buttonDeleteItem.setEnabled(false);
//			itemIDComboBox.setEnabled(true);
//			buttonEditTrial.setEnabled(false);
//			buttonDeleteTrial.setEnabled(false);
			buttonNewContinuousButton.setEnabled(true);
			buttonDeleteContinuousButton.setEnabled(false);
			spinner.setEnabled(false);
//			trialIDComboBox.removeAllItems();   //Commented out - stian
//			itemIDComboBox.removeAllItems();    //Commented out - stian
			MIDIButtonNumberContinuousComboBox.setSelectedItem("71");
		}
		
		if (cmd.equals("CONTINUOUSFADER")) {
			timeSlicespinner.setEnabled(true);
			MIDIButtonNumberContinuousComboBox.setEnabled(false);
            //Commented out - stian
//			buttonNewItem.setEnabled(true);
//			buttonEditItem.setEnabled(false);
//			buttonDeleteItem.setEnabled(false);
//			itemIDComboBox.setEnabled(true);
//			buttonEditTrial.setEnabled(false);
//			buttonDeleteTrial.setEnabled(false);
			buttonNewContinuousButton.setEnabled(false);
			buttonDeleteContinuousButton.setEnabled(false);
			spinner.setEnabled(true);
//			trialIDComboBox.removeAllItems();   //Commented out - stian
//			itemIDComboBox.removeAllItems();    //Commented out - stian
			MIDIButtonNumberContinuousComboBox.setSelectedItem("71");
		}
		
		if (cmd.equals("MIDIButtonNumberForward")) {
			if (MIDIButtonNumberForwardComboBox.getSelectedItem().
					equals(MIDIButtonNumberContinuousComboBox.getSelectedItem())){
				JOptionPane.showMessageDialog(frame,
						"MIDI Button Number already used! \n",
						"Warning!", JOptionPane.ERROR_MESSAGE);
				MIDIButtonNumberForwardComboBox.setSelectedItem("73");}
			if (MIDIButtonNumberForwardComboBox.getSelectedItem().
					equals(MIDIButtonNumberBackwardComboBox.getSelectedItem())){
				JOptionPane.showMessageDialog(frame,
						"MIDI Button Number already used! \n",
						"Warning!", JOptionPane.ERROR_MESSAGE);
				MIDIButtonNumberForwardComboBox.setSelectedItem("73");}	
		}
		
		if (cmd.equals("MIDIButtonNumberBackward")) {
			if (MIDIButtonNumberBackwardComboBox.getSelectedItem().
					equals(MIDIButtonNumberContinuousComboBox.getSelectedItem())){
				JOptionPane.showMessageDialog(frame,
						"MIDI Button Number already used! \n",
						"Warning!", JOptionPane.ERROR_MESSAGE);
				MIDIButtonNumberBackwardComboBox.setSelectedItem("72");}
			if (MIDIButtonNumberBackwardComboBox.getSelectedItem().
					equals(MIDIButtonNumberForwardComboBox.getSelectedItem())){
				JOptionPane.showMessageDialog(frame,
						"MIDI Button Number already used! \n",
						"Warning!", JOptionPane.ERROR_MESSAGE);
				MIDIButtonNumberBackwardComboBox.setSelectedItem("72");}
		}
	}
}
