package SALT.gui;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.event.ActionListener;

/**
 * The class Dialog provides methods, which most of the other dialogs need.
 * 
 */
public class Dialog extends Graphics {

	protected Object[] options = { "OK", "Cancel" };

	JPanel dialogPanel;

	/**
	 * Creates a new JPanel with the specified layout manager. All Components,
	 * like Buttons, Labels... have to be placed on a container (JPanel).
	 * 
	 * @see JPanel
	 */
	public Dialog() {
		dialogPanel = new JPanel(gridBagLayout);
	}

	/**
	 * Creates a Button. The method adds an action command, an ActionListener
	 * and a text to the button.
	 * 
	 * @param actionCommand
	 * @param label
	 * @param actionListener
	 * @return
	 * @see JButton
	 */
	protected JButton makeButton(String actionCommand, String label,
			ActionListener actionListener) {

		JButton button = new JButton();
		button.setActionCommand(actionCommand);
		button.addActionListener(actionListener);
		button.setText(label);

		return button;
	}

	/**
	 * Creates a title border of a JPanel.
	 * 
	 * @param titleText
	 */
	protected void setTitledBorder(String titleText) {
		TitledBorder titleBorder = BorderFactory.createTitledBorder(titleText);
		dialogPanel.setBorder(titleBorder);
	}
}
