/**
 * 
 */
package SALT.gui;

import java.awt.GridBagConstraints;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import SALT.assessment.Design;

/**
 * An input dialog to edit the MIDIControllerNumberOfFaders.
 * 
 */
public class FaderDialog extends Dialog {

	JPanel panel;
	JLabel Label;
	JTextField TextField;

	/**
	 * Constructs a FaderDialog.
	 */
	public FaderDialog() {

		panel = new JPanel(gridBagLayout);
		Label = new JLabel("Controller Number");
		TextField = new JTextField(10);

		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(Label, gridBagConstraints);
		panel.add(Label);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(TextField, gridBagConstraints);
		panel.add(TextField);
	}

	/**
	 * Displays the FaderDialog.
	 * 
	 * @param frame
	 * @param design
	 * @param selectedItem
	 */
	public void display(JFrame frame, Design design, int selectedItem) {

		TextField.setText(design.getMIDIControllerNumberOfFaders().get(
				selectedItem - 1).toString());

		boolean wrongInput = true;

		while (wrongInput == true) {
			wrongInput = false;

			int choosedOption = JOptionPane.showOptionDialog(frame, panel,
					"Edit Controller Number", JOptionPane.DEFAULT_OPTION,
					JOptionPane.INFORMATION_MESSAGE, null, options, options[0]);

			if (choosedOption == 0) {
				try {
					Integer.decode(TextField.getText());
					design.replaceMIDIControllerNumberOfFader(selectedItem - 1,
							Integer.valueOf(TextField.getText()));
				} catch (NumberFormatException e) {
					// TODO Auto-generated catch block
					// e.printStackTrace();
					JOptionPane.showMessageDialog(frame,
							"Please enter Controller Number numerical!",
							"Warning!", JOptionPane.ERROR_MESSAGE);
					wrongInput = true;
				}
			}
		}
	}
}

