package SALT.gui;

import java.awt.*;

/**
 * Provides graphical methods for Layout and Dialog.
 * 
 * @see GridBagConstraints
 * @see GridBagLayout
 */
public class Graphics {

	protected GridBagLayout gridBagLayout;
	protected GridBagConstraints gridBagConstraints;

	/**
	 * Initialise a GridBagLayout object and a GridBagConstraints object.
	 */
	public Graphics() {
		gridBagLayout = new GridBagLayout();
		gridBagConstraints = new GridBagConstraints();
	}

	/**
	 * Specifies constraints for components that are laid out using the
	 * GridBagLayout class.
	 * 
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 * @param gridBagContraints
	 */
	protected void makeGridBagConstraints(int x, int y, int width, int height,
			GridBagConstraints gridBagContraints) {
		gridBagContraints.gridx = x;
		gridBagContraints.gridy = y;
		gridBagContraints.gridwidth = width;
		gridBagContraints.gridheight = height;
		gridBagContraints.insets = new Insets(5, 5, 5, 5);
	}

}
