package SALT.gui;

import java.awt.GridBagConstraints;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

/**
 * Shows informations about SALT and the system, you are working with.
 *
 */
public class InformationDialog extends Dialog {
	
	JLabel SALTinformationLabel;
	JLabel SALTtextLabel;
	JLabel SysteminformationLabel;
	JLabel SystemtextLabel;
	
	JPanel SALTInformationsPanel;
	JPanel systemInformationsPanel;
	
	TitledBorder SALTInformationsTitle;
	TitledBorder systemInformationsTitle;
	
	/**
	 * Constructs an InformationDialog.
	 */
	public InformationDialog() {
		
		SALTInformationsPanel = new JPanel(gridBagLayout);
		systemInformationsPanel = new JPanel(gridBagLayout);
		
		SALTInformationsTitle = BorderFactory.createTitledBorder("SALT Informations");
		systemInformationsTitle = BorderFactory.createTitledBorder("System Informations");
		
		SALTInformationsPanel.setBorder(SALTInformationsTitle);
		systemInformationsPanel.setBorder(systemInformationsTitle);
		
		SALTinformationLabel = new JLabel("<html><p align=right>Version:<br>" + "Last Revision:<br>" + "Author:</p>");
		SALTtextLabel = new JLabel("<html>2.0<br>" + "October 2006<br>" + "Stefan Holzh�user, Mandy Weitzel</p>");
		
		SysteminformationLabel = new JLabel("<html><p align=right>Operating System:<tab><br>" + "Working Directory:<br>" + "JAVA Version:</p>");
		SystemtextLabel = new JLabel("<html>"+ System.getProperty("os.name") + "<br>" + System.getProperty("user.dir") + "<br>" + System.getProperty("java.version")+ "</p>");
			
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.EAST;
		gridBagLayout.setConstraints(SALTinformationLabel, gridBagConstraints);
		SALTInformationsPanel.add(SALTinformationLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(SALTtextLabel, gridBagConstraints);
		SALTInformationsPanel.add(SALTtextLabel);
				
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.EAST;
		gridBagLayout.setConstraints(SysteminformationLabel, gridBagConstraints);
		systemInformationsPanel.add(SysteminformationLabel);

		makeGridBagConstraints(1, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagLayout.setConstraints(SystemtextLabel, gridBagConstraints);
		systemInformationsPanel.add(SystemtextLabel);
				
		makeGridBagConstraints(0, 0, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(SALTInformationsPanel, gridBagConstraints);
		dialogPanel.add(SALTInformationsPanel);

		makeGridBagConstraints(0, 1, 1, 1, gridBagConstraints);
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagLayout.setConstraints(systemInformationsPanel, gridBagConstraints);
		dialogPanel.add(systemInformationsPanel);	
	}
	
	/**
	 * Displays the InformationDialog.
	 * @param frame
	 */
	public void display(JFrame frame) {
		JOptionPane.showMessageDialog(frame, dialogPanel, "About SALT", 
				JOptionPane.PLAIN_MESSAGE);
	}
}
