/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * NewItemDialog.java
 *
 * Created on 26.feb.2009, 18:43:04
 */

package gui;

import java.awt.event.KeyEvent;
import java.util.ArrayList;
import mediaplayer.Item;
import mediaplayer.Main;

/**
 *
 * @author Stian
 */
public class ItemDialog extends javax.swing.JDialog {

    ArrayList<String> fileList; //Stores eligible files
    boolean edit = false;

    /** Creates new form NewItemDialog
     * @param parent
     * @param modal
     * @param item
     */
    public ItemDialog(java.awt.Frame parent, boolean modal, Item item) {
        super(parent, modal);
        initComponents();

        setResizable(false);

        //Get the filelist from the main class
        fileList = Main.view.main.clipList;
        for(String s : fileList) {
            fileListComboBox.addItem(s);
        }
        if(item != null) {
            edit = true;
            
            nameField.setText(item.name);

            String s = "";
            for(String tag : item.tags) {
                s += tag+"\n";
            }
            tags.setText(s);

            boolean hasSelectedItem = false;
            for(int i=0;i<fileListComboBox.getItemCount();i++) {
                if(item.filename.equals(fileListComboBox.getItemAt(i))) {
                    fileListComboBox.setSelectedIndex(i);
                    hasSelectedItem = true;
                }
            }
            if(!hasSelectedItem) {
                fileListComboBox.addItem(item.filename);
                fileListComboBox.setSelectedIndex(fileListComboBox.getItemCount()-1);
            }
        }
    }

    /**
     * Edits an item.
     * Used only by this class, so the item can be found by looking at the given attributes in the form
     */
    private void editItem() {

        Item item = new Item(nameField.getText(), 
                fileListComboBox.getSelectedItem().toString(),
                Main.view.main.listPacket.clips.get(fileListComboBox.getSelectedIndex()));
        item.setTags(tags.getText());

        //Get the item and set its properties
        TrialDialog td = TrialDialog.trialDialog;
        if(td.itemList.getSelectedValue()!=null) {
            int selectedIndex = td.itemList.getSelectedIndex();
            td.items[selectedIndex] = item;
            td.dlm.setElementAt(td.items[selectedIndex].toString(), selectedIndex);
        } else {
            Main.view.main.status.AddMessage("No item to edit");
        }
    }

    /**
     * Creates a new item based on the form
     */
    private void newItem() {

        Item item = new Item(nameField.getText(), 
                fileListComboBox.getSelectedItem().toString(),
                Main.view.main.listPacket.clips.get(fileListComboBox.getSelectedIndex()));
        item.setTags(tags.getText());
        TrialDialog td = TrialDialog.trialDialog;
        if(td.itemList.getSelectedValue()!=null) {
            int selectedIndex = td.itemList.getSelectedIndex();
            td.items[selectedIndex] = item;
            td.dlm.setElementAt(td.items[selectedIndex].toString(), selectedIndex);
        } else {
            //TODO: Problem with what is selected
        }
        //TODO: set group
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        nameLabel = new javax.swing.JLabel();
        nameField = new javax.swing.JTextField();
        tagLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tags = new javax.swing.JTextArea();
        fileLabel = new javax.swing.JLabel();
        fileListComboBox = new javax.swing.JComboBox();
        cancelButton = new javax.swing.JButton();
        okButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(mediaplayer.MediaPlayerApp.class).getContext().getResourceMap(ItemDialog.class);
        nameLabel.setText(resourceMap.getString("nameLabel.text")); // NOI18N
        nameLabel.setName("nameLabel"); // NOI18N

        nameField.setText(resourceMap.getString("nameField.text")); // NOI18N
        nameField.setName("nameField"); // NOI18N
        nameField.setPreferredSize(new java.awt.Dimension(65, 20));
        nameField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                nameFieldKeyReleased(evt);
            }
        });

        tagLabel.setText(resourceMap.getString("tagLabel.text")); // NOI18N
        tagLabel.setName("tagLabel"); // NOI18N
        tagLabel.setPreferredSize(new java.awt.Dimension(31, 14));

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        tags.setColumns(20);
        tags.setRows(5);
        tags.setName("tags"); // NOI18N
        tags.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tagsKeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(tags);

        fileLabel.setText(resourceMap.getString("fileLabel.text")); // NOI18N
        fileLabel.setName("fileLabel"); // NOI18N
        fileLabel.setPreferredSize(new java.awt.Dimension(31, 14));

        fileListComboBox.setName("fileListComboBox"); // NOI18N
        fileListComboBox.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                fileListComboBoxKeyReleased(evt);
            }
        });

        cancelButton.setText(resourceMap.getString("cancelButton.text")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        okButton.setText(resourceMap.getString("okButton.text")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.setPreferredSize(new java.awt.Dimension(65, 23));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(nameLabel)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(2, 2, 2)
                                .addComponent(fileLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(nameField, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(fileListComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(tagLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(48, 48, 48)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(cancelButton)))
                .addContainerGap(49, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(nameLabel)
                    .addComponent(nameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(fileLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(fileListComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(cancelButton)))
                    .addComponent(tagLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        //Handles errors and if it is ok, then edit/create new item.
        boolean isOk = true;
        if(nameField.getText().matches("")) {
            Main.view.main.status.AddMessage("Need to fill out a name");
            isOk = false;
        }
        if(fileListComboBox.getSelectedItem() == null) {
            Main.view.main.status.AddMessage("Need to choose a file");
            isOk = false;
        }
        if(!isOk) return;
        if(edit) {
            editItem();
        } else {
            newItem();
        }
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void nameFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_nameFieldKeyReleased
        if(evt.getKeyCode()==KeyEvent.VK_ESCAPE) dispose();
        if(evt.getKeyCode()==KeyEvent.VK_ENTER) {
            boolean isOk = true;
            if(nameField.getText().matches("")) {
                Main.view.main.status.AddMessage("Need to fill out a name");
                isOk = false;
            }
            if(fileListComboBox.getSelectedItem() == null) {
                Main.view.main.status.AddMessage("Need to choose a file");
                isOk = false;
            }
            if(!isOk) return;
            if(edit) {
                editItem();
            } else {
                newItem();
            }
            dispose();
        }
    }//GEN-LAST:event_nameFieldKeyReleased

    private void fileListComboBoxKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_fileListComboBoxKeyReleased
        if(evt.getKeyCode()==KeyEvent.VK_ESCAPE) dispose();
    }//GEN-LAST:event_fileListComboBoxKeyReleased

    private void tagsKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tagsKeyReleased
        if(evt.getKeyCode()==KeyEvent.VK_ESCAPE) dispose();
    }//GEN-LAST:event_tagsKeyReleased

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                ItemDialog dialog = new ItemDialog(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel fileLabel;
    private javax.swing.JComboBox fileListComboBox;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField nameField;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JButton okButton;
    private javax.swing.JLabel tagLabel;
    private javax.swing.JTextArea tags;
    // End of variables declaration//GEN-END:variables


}
