package mediaplayer;

import packets.Clip;
import java.util.ArrayList;

/**
 *
 * @author Stian
 */
public class Item {

    /**
     * item name
     */
    public String name;
    /**
     * filename for the clip. also present in the clip, extra accessibility for convienience
     */
    public String filename;
    /**
     * clip associated with the item
     */
    public Clip clip;
    /**
     * list of associated tags
     */
    public ArrayList<String> tags;
    /**
     * start of clip in time code
     */
    public String tcStart;
    /**
     * time code stop position
     */
    public String tcStop;

    /**
     *
     * @param name
     * @param filename
     * @param clip
     */
    public Item(String name, String filename, Clip clip) {

        this.name = name;
        this.filename = filename;
        this.clip = clip;
        tags = new ArrayList<String>();

    }

    /**
     * create a copy of an item
     * @param item
     */
    public Item(Item item) {
        this.name = item.name;
        this.filename = item.filename;
        this.tags = item.tags;
        this.clip = item.clip;
    }

    /**
     * parses a string and sets as tags
     * @param tagsStringed
     */
    public void setTags(String tagsStringed) {

        tags = new ArrayList<String>();
        String[] tagsList = tagsStringed.split("\n");
        for(int i=0;i<tagsList.length;i++) {
            if(!tagsList[i].matches("")) {
                tags.add(tagsList[i]);
            }
        }
    }

    /**
     * get tags as a single string
     * @return
     */
    public String getShortTag() {
        String s = "";
        for(int i=0;i<tags.size();i++)  {
            s += tags.get(i);
            if(i!=tags.size()-1) {
                s += ", ";
            }
        }
        return s;
    }

    @Override
    public String toString() {
        return name;
    }

}
