/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mediaplayer;

import gui.StatusFrame;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.Timer;

/**
 *
 * @author Stian
 */
public class Status {

    /**
     *
     */
    public boolean designStatus = false;
    /**
     *
     */
    public boolean sessionStatus = false;
    /**
     *
     */
    public boolean connectionStatus = false;
    /**
     *
     */
    public boolean filelistStatus = false;
    /**
     *
     */
    public boolean randomizeStatus = false;

    /**
     * List of strings shown in the messagefield in the status window
     */
    public ArrayList<String> messageFieldStrings;

    /**
     * This status frame
     */
    public static StatusFrame sf;

    /**
     *
     */
    public Status() {

        messageFieldStrings = new ArrayList<String>();
        sf = new StatusFrame();
    }

    /**
     * adds messages to the messagefield
     * @param msg
     */
    public void AddMessage(String msg) {
        messageFieldStrings.add(msg);
        updateMessageField();
        (new Timer(5000,
            new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    if(messageFieldStrings.size()!=0) messageFieldStrings.remove(0);
                    updateMessageField();
                }
            }
        )).start();
    }

    private void updateMessageField() {
        String total = "";
        for(int i=0;i<messageFieldStrings.size();i++) {
            total += messageFieldStrings.get(i);
            if(i!=messageFieldStrings.size()-1) total += "\n";
        }
        sf.messageTextArea.setText(total);
    }

    /**
     *
     * @return
     */
    public boolean isConnectionStatus() {
        return connectionStatus;
    }

    /**
     * 
     * @param connectionStatus
     * @param message
     */
    public void setConnectionStatus(boolean connectionStatus, String message) {
        this.connectionStatus = connectionStatus;
        sf.clipRecorderStatus.setText(message);
        if(connectionStatus) {
            sf.clipRecorderStatus.setForeground(Color.green);
        } else {
            sf.clipRecorderStatus.setForeground(Color.red);
        }
    }

    /**
     *
     * @return
     */
    public boolean isDesignStatus() {
        return designStatus;
    }

    /**
     *
     * @param designStatus
     */
    public void setDesignStatus(boolean designStatus) {
        this.designStatus = designStatus;
        if(designStatus) {
            sf.designStatus.setText("Design specified");
            sf.designStatus.setForeground(Color.green);
        } else {
            sf.designStatus.setText("Not specified");
            sf.designStatus.setForeground(Color.red);
        }
    }

    /**
     *
     * @return
     */
    public boolean isFilelistStatus() {
        return filelistStatus;
    }

    /**
     *
     * @param filelistStatus
     */
    public void setFilelistStatus(boolean filelistStatus) {
        this.filelistStatus = filelistStatus;
        if(filelistStatus) {
            sf.filelistStatus.setText("Filelist received");
            sf.filelistStatus.setForeground(Color.green);
        } else {
            sf.filelistStatus.setText("No filelist");
            sf.filelistStatus.setForeground(Color.red);
        }
    }

    /**
     *
     * @return
     */
    public boolean isRandomizeStatus() {
        return randomizeStatus;
    }

    /**
     *
     * @param randomizeStatus
     */
    public void setRandomizeStatus(boolean randomizeStatus) {
        this.randomizeStatus = randomizeStatus;
        if(randomizeStatus) {
            sf.randomizingStatus.setText("Randomizing completed");
            sf.randomizingStatus.setForeground(Color.green);
        } else {
            sf.randomizingStatus.setText("No randomizing completed");
            sf.randomizingStatus.setForeground(Color.red);
        }
    }

    /**
     *
     * @return
     */
    public boolean isSessionStatus() {
        return sessionStatus;
    }

    /**
     *
     * @param sessionStatus
     */
    public void setSessionStatus(boolean sessionStatus) {
        this.sessionStatus = sessionStatus;
        if(sessionStatus) {
            sf.sessionStatus.setText("Session specified");
            sf.sessionStatus.setForeground(Color.green);
        } else {
            sf.sessionStatus.setText("Not specified");
            sf.sessionStatus.setForeground(Color.red);
        }
    }

    /**
     * checks all requirements for starting a subjective assessment
     * @return
     */
    public boolean isAllRequirementsFulfilled() {
        boolean b = true;
        if(!isConnectionStatus()) b = false;
        if(!isSessionStatus()) b = false;
        if(!isDesignStatus()) b = false;
        if(!isFilelistStatus()) b = false;
        if(!isRandomizeStatus()) b = false;

        return b;
    }

    @Override
    public String toString() {
        return "status";
    }

}
