package mediaplayer;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.Receiver;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.Transmitter;

/**
 * this class receives time code from the tascam. this class is untested!
 * @author Stian
 */
public class TimeCodeListenerThread extends Thread implements Receiver {

        Transmitter trans;
        MidiDevice inputDevice;

        int hours, minutes, seconds, frames;
        String timecode;
        int[] lastValues;

        /**
         *
         */
        public TimeCodeListenerThread() {

            timecode = "00:00:00:00";
            hours = 0;
            minutes = 0;
            seconds = 0;
            frames = 0;
            lastValues = new int[8];

            start();

        }

        public void send(MidiMessage message, long timeStamp) {
            if(!(message instanceof ShortMessage)) {
                return;
            }
            ShortMessage msg = (ShortMessage)message;
            int status = message.getStatus();
            if(status==0x000000F1) {        //Is it quarter frame timecode?
                int nibble = (msg.getData1() & 0x000000F0) >> 4; //sets the nibble. only 4bits
                int value = (msg.getData1() & 0x0000000F);  //sets the given values. only 4bits
                if(lastValues[nibble]!=value) {
                    switch(nibble) {
                        case 0: {
                            frames = ((frames & 0x000000F0) | value);
                            lastValues[0] = frames;
                            break;
                        }
                        case 1: {
                            frames = ((frames & 0x0000000F) | (value<<4));
                            lastValues[1] = frames;
                            break;
                        }
                        case 2: {
                            seconds = ((seconds & 0x000000F0) | value);
                            lastValues[2] = seconds;
                            break;
                        }
                        case 3: {
                            seconds = ((seconds & 0x0000000F) | (value<<4));
                            lastValues[3] = seconds;
                            break;
                        }
                        case 4: {
                            minutes = ((minutes & 0x000000F0) | value);
                            lastValues[4] = minutes;
                            break;
                        }
                        case 5: {
                            minutes = ((minutes & 0x0000000F) | (value<<4));
                            lastValues[5] = minutes;
                            break;
                        }
                        case 6: {
                            hours = ((hours & 0x000000F0) | value);
                            lastValues[6] = hours;
                            break;
                        }
                        case 7: {
                            hours = ((hours & 0x0000000F) | ((value-6)<<4));    //this is hard coded to use smpte value=6
                            lastValues[7] = hours;
                            break;
                        }
                    }
                    if(nibble==7) {
                        timecode = "";
                        if((hours+"").length()<2) {
                            timecode += "0"+hours+":";
                        } else {
                            timecode += hours+":";
                        }
                        if((minutes+"").length()<2) {
                            timecode += "0"+minutes+":";
                        } else {
                            timecode += minutes+":";
                        }
                        if((seconds+"").length()<2) {
                            timecode += "0"+seconds+":";
                        } else {
                            timecode += seconds+":";
                        }
                        if((frames+"").length()<2) {
                            timecode += "0"+frames;
                        } else {
                            timecode += frames;
                        }
                        Main.view.main.setTimeCode(timecode);
                    }
                }
            }
        }

        public void close() {

        }

    }