/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Trial.java
 *
 * Created on 02.apr.2009, 12:51:49
 */

package mediaplayer;

import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Collections;
import javax.swing.DefaultListModel;

/**
 * This class represents a trial, including a list of items
 * @author Stian
 */
public class Trial extends javax.swing.JPanel {

    /**
     * Counter for the identifier
     */
    public static int index = 0;
    /**
     * number of items per trial
     */
    public static int itemsPerTrial = 1;

    private DefaultListModel dlm;

    /**
     * identifier
     */
    public int id;
    /**
     * list of items. fixed nr of items
     */
    public Item[] items;

    /**
     * 
     * @param name
     */
    public Trial(String name) {

        super();
        initComponents();
        setName(name);
        titleLabel.setText(name);
        id = index;
        index++;

        items = new Item[getItemsPerTrial()];

        for(int i=0;i<items.length;i++) {
            items[i] = null;
        }
        
        resizeItemList();   //Called to fix resizing
        itemList.setSelectionBackground(new Color(96,96,255));
        dlm = new DefaultListModel();
        itemList.setModel(dlm);
    }

    /**
     * shuffles items in the trial. no validity guaranteed
     */
    public void shuffle() {
        ArrayList<Item> newItemList = new ArrayList<Item>();
        for(Item i : items) {
            newItemList.add(i);
        }
        Collections.shuffle(newItemList);
        for(int i=0;i<newItemList.size();i++) {
            items[i] = newItemList.get(i);
        }
    }

    /**
     *
     * @return
     */
    public int getId() {
        return id;
    }

    /**
     *
     * @return
     */
    public static int getItemsPerTrial() {
        String s = Main.view.nrOfItemsComboBox.getSelectedItem().toString();
        String[] snrl = s.split(" ");
        String snr = snrl[0];
        int nr = Integer.parseInt(snr);
        return nr;
    }

    @Override
    public String toString() {

        String r = getName()+"\n";
        for(int i=0;i<items.length;i++) {
            r += items[i].toString();
            if(i!=items.length-1) {
                r += "\n";
            }
        }
        return r;
    }
    
    private void resizeItemList() {
        int scrollHeight = getItemsPerTrial()*16 + 5;
        int panelHeight = scrollHeight + 20;
        this.setPreferredSize(new Dimension(this.getPreferredSize().width, panelHeight));
        itemListScroll.setPreferredSize(new Dimension(itemListScroll.getPreferredSize().width, scrollHeight));
        itemListScroll.revalidate();
        itemListScroll.setPreferredSize(new Dimension(itemListScroll.getPreferredSize().width, scrollHeight));
        itemListScroll.revalidate();
    }

    /**
     * Updates descrition of trial in gui
     */
    public void updateDescription() {
        dlm.clear();
        for(int i=0;i<items.length;i++) {
            if(items[i]!=null) {
                dlm.addElement(items[i].toString());
            } else {
                dlm.addElement("Not yet added");
            }
        }
        resizeItemList();
    }

    /**
     * a repaint method
     */
    public void rearrange() {
        dlm.clear();
        for(int i=0;i<items.length;i++) {
            dlm.addElement(items[i]);
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        titleLabel = new javax.swing.JLabel();
        itemListScroll = new javax.swing.JScrollPane();
        itemList = new javax.swing.JList();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setMaximumSize(new java.awt.Dimension(275, 32767));
        setName("Form"); // NOI18N
        setPreferredSize(new java.awt.Dimension(215, 35));

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(mediaplayer.MediaPlayerApp.class).getContext().getResourceMap(Trial.class);
        titleLabel.setFont(resourceMap.getFont("titleLabel.font")); // NOI18N
        titleLabel.setText(resourceMap.getString("titleLabel.text")); // NOI18N
        titleLabel.setMaximumSize(new java.awt.Dimension(63, 16));
        titleLabel.setName("titleLabel"); // NOI18N

        itemListScroll.setBorder(null);
        itemListScroll.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        itemListScroll.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        itemListScroll.setName("itemListScroll"); // NOI18N

        itemList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        itemList.setName("itemList"); // NOI18N
        itemListScroll.setViewportView(itemList);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(titleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 88, Short.MAX_VALUE)
                .addComponent(itemListScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 125, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(itemListScroll, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 16, Short.MAX_VALUE)
                    .addComponent(titleLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JList itemList;
    private javax.swing.JScrollPane itemListScroll;
    private javax.swing.JLabel titleLabel;
    // End of variables declaration//GEN-END:variables

}
